<?php

namespace App\Composant\User\Infrastructure;

use App\Composant\User\Domain\User;
use App\Composant\User\Domain\UserDataMapper;
use Doctrine\Persistence\ManagerRegistry;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Exception;

class DoctrineUser extends ServiceEntityRepository implements UserDataMapper
{

    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, User::class);
    }

    public function findById(int $id): User
    {
        $entityManager = $this->getEntityManager();
        $User = $entityManager->getRepository(User::class)->find($id);
        if (!$User) {
            throw new Exception(
                'L\'utilisateur n\'existe pas'
            );
        }

        return $User;
    }

    public function findAll(): array
    {
        // TODO: Implement findAll() method.
    }
}